"{ Package: 'jv:libgdbs' }"

GDBMICommand subclass:#GDBMI_target_attach
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GDB-Core-Commands-MI'
!

!GDBMI_target_attach class methodsFor:'documentation'!

documentation
"
The `-target-attach' Command
----------------------------

Synopsis
........

      -target-attach PID | GID | FILE

   Attach to a process PID or a file FILE outside of {No value for
`GDBN'}, or a thread group GID.  If attaching to a thread group, the id
previously returned by `-list-thread-groups --available' must be used.

{No value for `GDBN'} Command
.............................

The corresponding {No value for `GDBN'} command is `attach'.

Example
.......

     (gdb)
     -target-attach 34
     =thread-created,id='1'
     *stopped,thread-id='1',frame={addr='0xb7f7e410',func='bar',args=[]}
     ^done
     (gdb)


"
! !

!GDBMI_target_attach methodsFor:'accessing'!

operation
	^ 'target-attach'
! !

!GDBMI_target_attach class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

